Overview | Package | Class | Tree | Serialized | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.ibm.workplace.wcm.api
Interface HistoryLogEntryCodes

    public interface HistoryLogEntryCodes

A list of event codes returned by the ``HistoryLogEntry.getCode()``.

A `HistoryLogEntryCode` value less than `0` represents an errors or undefined state.
A `HistoryLogEntryCode` value between `1000` and `1999` inclusive represents an authoring entry.
A `HistoryLogEntryCode` value between `2000` and `2999` inclusive represents a draft entry.
A `HistoryLogEntryCode` value between `3000` and `3999` inclusive represents a state transition.
A `HistoryLogEntryCode` value between `4000` and `4999` inclusive represents a workflow entry.
A `HistoryLogEntryCode` value between `5000` and `5999` inclusive represents a project entry.
A `HistoryLogEntryCode` value between `10000` and `19999` inclusive represents a free form comment entry.
A `HistoryLogEntryCode` value between `20000` and `29999` inclusive represents a History Log maintenance entry.

Field Summary
`static int` | `API_FREE_FORM_MESSAGE` A free form `HistoryLogEntry` created using the public API.
`static int` | `COMMENT_DRAFT_CANCELED` A free form comment `HistoryLogEntry` entered when a draft Document was cancelLed.
`static int` | `COMMENT_DRAFT_CREATED` A free form comment `HistoryLogEntry` entered when a draft Document was created.
`static int` | `COMMENT_PROJECT_APPROVAL_WITHDRAWN` A free form comment `HistoryLogEntry` entered when an approval is withdrawn from a Project.
`static int` | `COMMENT_PROJECT_SUBMITTED_FOR_REVIEW` A free form comment `HistoryLogEntry` entered when a Project is submitted for Review.
`static int` | `COMMENT_PROJECT_WITHDRAWN_FROM_REVIEW` A free form comment `HistoryLogEntry` entered when a Project is withdrawn for Review.
`static int` | `COMMENT_WORKFLOW_APPROVED` A free form comment `HistoryLogEntry` entered when a Document was reviewed and approved.
`static int` | `COMMENT_WORKFLOW_NEXT_STAGE` A free form comment `HistoryLogEntry` entered when a Document was moved to the next Workflow stage.
`static int` | `COMMENT_WORKFLOW_PREVIOUS_STAGE` A free form comment `HistoryLogEntry` entered when a Document was moved to the previous Workflow stage.
`static int` | `COMMENT_WORKFLOW_PROCESS_NOW` A free form comment `HistoryLogEntry` entered when a Document manually executed a scheduled action.
`static int` | `COMMENT_WORKFLOW_PUBLISHED` A free form comment `HistoryLogEntry` entered when a Document was published.
`static int` | `COMMENT_WORKFLOW_REJECTED` A free form comment `HistoryLogEntry` entered when a Document was reviewed and rejected.
`static int` | `COMMENT_WORKFLOW_RESTARTED` A free form comment `HistoryLogEntry` entered when the Workflow was restarted on a Document.
`static int` | `DOCUMENT_APPLY_AUTHORING_TEMPLATE` A `HistoryLogEntry` recording a Authoring Template being applied to a Document.
`static int` | `DOCUMENT_CREATED` A `HistoryLogEntry` recording the creation of a new Document.
`static int` | `DOCUMENT_CREATED_AS_COPY` A `HistoryLogEntry` recording the creation of a new Document as a copy of another Document.
`static int` | `DOCUMENT_DELETED` A `HistoryLogEntry` recording a Document being deleted.
`static int` | `DOCUMENT_IMPORTED` A `HistoryLogEntry` recording a Document being imported.
`static int` | `DOCUMENT_MOVED` A `HistoryLogEntry` recording a Document being moved.
`static int` | `DOCUMENT_REVERTED` A `HistoryLogEntry` recording the a Document being reverted to an old version.
`static int` | `DOCUMENT_UPDATED` A `HistoryLogEntry` recording an update to a Document.
`static int` | `DRAFT_CANCELED` A `HistoryLogEntry` recording the cancellation of a draft Document.
`static int` | `DRAFT_CREATED` A `HistoryLogEntry` recording the creation of a draft Document.
`static int` | `HISTORY_ENTRIES_REMOVED` A `HistoryLogEntry` recording that the `HistoryLog` has entries removed.
`static int` | `PROJECT_APPROVAL_WITHDRAWN` A `HistoryLogEntry` recording an approval being removed from a Project.
`static int` | `PROJECT_APPROVED` A `HistoryLogEntry` recording a Project being approved.
`static int` | `PROJECT_CHANGED_STATE` Deprecated. use PROJECT_ENTERED_{state} instead.
`static int` | `PROJECT_DOCUMENT_ADDED` A `HistoryLogEntry` recording a Document being added to a Project.
`static int` | `PROJECT_DOCUMENT_REMOVED` A `HistoryLogEntry` recording a Document being removed from a Project.
`static int` | `PROJECT_ENTERED_ACTIVE` A `HistoryLogEntry` recording a Project entering ACTIVE state.
`static int` | `PROJECT_ENTERED_PENDING` A `HistoryLogEntry` recording a Project entering PENDING state.
`static int` | `PROJECT_ENTERED_PUBLISH_FAILED` A `HistoryLogEntry` recording a Project entering PUBLISHED_FAILED state.
`static int` | `PROJECT_ENTERED_PUBLISHED` A `HistoryLogEntry` recording a Project entering PUBLISHED state.
`static int` | `PROJECT_ENTERED_PUBLISHING` A `HistoryLogEntry` recording a Project entering PUBLISHING state.
`static int` | `PROJECT_ENTERED_REJECTED` A `HistoryLogEntry` recording a Project entering REJECTED state.
`static int` | `PROJECT_ENTERED_REVIEW` A `HistoryLogEntry` recording a Project entering REVIEW state.
`static int` | `PROJECT_ENTERED_SYNDICATING` A `HistoryLogEntry` recording a Project entering SYNDICATING state.
`static int` | `PROJECT_PUBLISHED_STATE` A `HistoryLogEntry` recording a Project changing state.
`static int` | `PROJECT_REJECTED` A `HistoryLogEntry` recording a Project being rejected.
`static int` | `PROJECT_SUBMITTED_FOR_REVIEW` A `HistoryLogEntry` recording a Project being submitted for Review.
`static int` | `PROJECT_VALIDATION_CANCELLED_DUE_TO_PUBLISHING` A `HistoryLogEntry` recording a project validation being cancelled due to a project publish being initiated The value of this `HistoryLogEntryCode` is `5210`.
`static int` | `PROJECT_VALIDATION_CANCELLED_DUE_TO_UPDATE` A `HistoryLogEntry` recording a project validation being cancelled due to the project being updated The value of this `HistoryLogEntryCode` is `5211`.
`static int` | `PROJECT_VALIDATION_COMPLETE` A `HistoryLogEntry` recording a project validation is complete with no errors The value of this `HistoryLogEntryCode` is `5220`.
`static int` | `PROJECT_VALIDATION_COMPLETE_WITH_ERRORS` A `HistoryLogEntry` recording a project validation is complete with errors The value of this `HistoryLogEntryCode` is `5230`.
`static int` | `PROJECT_VALIDATION_STARTED` A `HistoryLogEntry` recording a project starting a validation The value of this `HistoryLogEntryCode` is `5200`.
`static int` | `PROJECT_WITHDRAWN_FROM_REVIEW` A `HistoryLogEntry` recording a Project being withdrawn from Review.
`static int` | `STATE_REVERT_TO_DRAFT` A `HistoryLogEntry` recording a backward state transition to draft.
`static int` | `STATE_REVERT_TO_PUBLISHED` A `HistoryLogEntry` recording a backward state transition to published.
`static int` | `STATE_TO_PENDING_PUBLISHED` A `HistoryLogEntry` recording a forward transition to pending published.
`static int` | `STATE_TO_PUBLISHED` A `HistoryLogEntry` recording a forward state transition to published.
`static int` | `UNAVAILABLE` A legacy `HistoryLogEntry` without a `HistoryLogEntryCode`.
`static int` | `WORKFLOW_APPROVED` A `HistoryLogEntry` recording a Document being reviewed and approved.
`static int` | `WORKFLOW_CHANGED` A `HistoryLogEntry` recording a Workflow change on a Document.
`static int` | `WORKFLOW_NEXT_STAGE` A `HistoryLogEntry` recording a Document moving to another Workflow stage The value of this `HistoryLogEntryCode` is `3100`.
`static int` | `WORKFLOW_REJECTED` A `HistoryLogEntry` recording a Document being reviewed and rejected.
`static int` | `WORKFLOW_REJECTED_STAGE_EXECUTED` A `HistoryLogEntry` recording a Document being reviewed and rejected then executing a specified Workflow stage.
`static int` | `WORKFLOW_RESTARTED` A `HistoryLogEntry` recording a Workflow restart on a Document.

Field Detail

### UNAVAILABLE

    static final int UNAVAILABLE

  A legacy `HistoryLogEntry` without a `HistoryLogEntryCode`.
  The value of this `HistoryLogEntryCode` is `-1`.

  See Also:
    Constant Field Values

### DOCUMENT_CREATED

    static final int DOCUMENT_CREATED

  A `HistoryLogEntry` recording the creation of a new Document.
  The value of this `HistoryLogEntryCode` is `1100`.

  See Also:
    Constant Field Values

### DOCUMENT_CREATED_AS_COPY

    static final int DOCUMENT_CREATED_AS_COPY

  A `HistoryLogEntry` recording the creation of a new Document as a copy of another Document.
  The value of this `HistoryLogEntryCode` is `1200`.

  See Also:
    Constant Field Values

### DOCUMENT_UPDATED

    static final int DOCUMENT_UPDATED

  A `HistoryLogEntry` recording an update to a Document.
  The value of this `HistoryLogEntryCode` is `1300`.

  See Also:
    Constant Field Values

### DOCUMENT_MOVED

    static final int DOCUMENT_MOVED

  A `HistoryLogEntry` recording a Document being moved.
  The value of this `HistoryLogEntryCode` is `1400`.

  See Also:
    Constant Field Values

### DOCUMENT_REVERTED

    static final int DOCUMENT_REVERTED

  A `HistoryLogEntry` recording the a Document being reverted to an old version.
  The value of this `HistoryLogEntryCode` is `1500`.

  See Also:
    Constant Field Values

### DOCUMENT_IMPORTED

    static final int DOCUMENT_IMPORTED

  A `HistoryLogEntry` recording a Document being imported.
  The value of this `HistoryLogEntryCode` is `1600`.

  See Also:
    Constant Field Values

### DOCUMENT_DELETED

    static final int DOCUMENT_DELETED

  A `HistoryLogEntry` recording a Document being deleted.
  The value of this `HistoryLogEntryCode` is `1700`.

  See Also:
    Constant Field Values

### DOCUMENT_APPLY_AUTHORING_TEMPLATE

    static final int DOCUMENT_APPLY_AUTHORING_TEMPLATE

  A `HistoryLogEntry` recording a Authoring Template being applied to a Document.
  The value of this `HistoryLogEntryCode` is `1800`.

  See Also:
    Constant Field Values

### DRAFT_CANCELED

    static final int DRAFT_CANCELED

  A `HistoryLogEntry` recording the cancellation of a draft Document.
  The value of this `HistoryLogEntryCode` is `2100`.

  See Also:
    Constant Field Values

### DRAFT_CREATED

    static final int DRAFT_CREATED

  A `HistoryLogEntry` recording the creation of a draft Document.
  The value of this `HistoryLogEntryCode` is `2200`.

  See Also:
    Constant Field Values

### WORKFLOW_NEXT_STAGE

    static final int WORKFLOW_NEXT_STAGE

  A `HistoryLogEntry` recording a Document moving to another Workflow stage
  The value of this `HistoryLogEntryCode` is `3100`.

  See Also:
    Constant Field Values

### WORKFLOW_APPROVED

    static final int WORKFLOW_APPROVED

  A `HistoryLogEntry` recording a Document being reviewed and approved.
  The value of this `HistoryLogEntryCode` is `3200`.

  See Also:
    Constant Field Values

### WORKFLOW_REJECTED

    static final int WORKFLOW_REJECTED

  A `HistoryLogEntry` recording a Document being reviewed and rejected.
  The value of this `HistoryLogEntryCode` is 3300.

  See Also:
    Constant Field Values

### WORKFLOW_REJECTED_STAGE_EXECUTED

    static final int WORKFLOW_REJECTED_STAGE_EXECUTED

  A `HistoryLogEntry` recording a Document being reviewed and rejected then executing a specified Workflow stage.
  The value of this `HistoryLogEntryCode` is `3310`.

  See Also:
    Constant Field Values

### WORKFLOW_RESTARTED

    static final int WORKFLOW_RESTARTED

  A `HistoryLogEntry` recording a Workflow restart on a Document.
  The value of this `HistoryLogEntryCode` is `3400`.

  See Also:
    Constant Field Values

### WORKFLOW_CHANGED

    static final int WORKFLOW_CHANGED

  A `HistoryLogEntry` recording a Workflow change on a Document.
  The value of this `HistoryLogEntryCode` is `3500`.

  See Also:
    Constant Field Values

### STATE_TO_PUBLISHED

    static final int STATE_TO_PUBLISHED

  A `HistoryLogEntry` recording a forward state transition to published.
  The value of this `HistoryLogEntryCode` is `4100`.

  See Also:
    Constant Field Values

### STATE_TO_PENDING_PUBLISHED

    static final int STATE_TO_PENDING_PUBLISHED

  A `HistoryLogEntry` recording a forward transition to pending published.
  The value of this `HistoryLogEntryCode` is `4200`.

  See Also:
    Constant Field Values

### STATE_REVERT_TO_DRAFT

    static final int STATE_REVERT_TO_DRAFT

  A `HistoryLogEntry` recording a backward state transition to draft.
  The value of this `HistoryLogEntryCode` is `4400`.

  See Also:
    Constant Field Values

### STATE_REVERT_TO_PUBLISHED

    static final int STATE_REVERT_TO_PUBLISHED

  A `HistoryLogEntry` recording a backward state transition to published.
  The value of this `HistoryLogEntryCode` is `4500`.

  See Also:
    Constant Field Values

### PROJECT_VALIDATION_STARTED

    static final int PROJECT_VALIDATION_STARTED

  A `HistoryLogEntry` recording a project starting a validation
  The value of this `HistoryLogEntryCode` is `5200`.

  See Also:
    Constant Field Values

### PROJECT_VALIDATION_CANCELLED_DUE_TO_PUBLISHING

    static final int PROJECT_VALIDATION_CANCELLED_DUE_TO_PUBLISHING

  A `HistoryLogEntry` recording a project validation being cancelled due to a project publish being initiated
  The value of this `HistoryLogEntryCode` is `5210`.

  See Also:
    Constant Field Values

### PROJECT_VALIDATION_CANCELLED_DUE_TO_UPDATE

    static final int PROJECT_VALIDATION_CANCELLED_DUE_TO_UPDATE

  A `HistoryLogEntry` recording a project validation being cancelled due to the project being updated
  The value of this `HistoryLogEntryCode` is `5211`.

  See Also:
    Constant Field Values

### PROJECT_VALIDATION_COMPLETE

    static final int PROJECT_VALIDATION_COMPLETE

  A `HistoryLogEntry` recording a project validation is complete with no errors
  The value of this `HistoryLogEntryCode` is `5220`.

  See Also:
    Constant Field Values

### PROJECT_VALIDATION_COMPLETE_WITH_ERRORS

    static final int PROJECT_VALIDATION_COMPLETE_WITH_ERRORS

  A `HistoryLogEntry` recording a project validation is complete with errors
  The value of this `HistoryLogEntryCode` is `5230`.

  See Also:
    Constant Field Values

### PROJECT_DOCUMENT_ADDED

    static final int PROJECT_DOCUMENT_ADDED

  A `HistoryLogEntry` recording a Document being added to a Project.
  The value of this `HistoryLogEntryCode` is `5300`.

  See Also:
    Constant Field Values

### PROJECT_DOCUMENT_REMOVED

    static final int PROJECT_DOCUMENT_REMOVED

  A `HistoryLogEntry` recording a Document being removed from a Project.
  The value of this `HistoryLogEntryCode` is `5400`.

  See Also:
    Constant Field Values

### PROJECT_CHANGED_STATE

    static final int PROJECT_CHANGED_STATE

  Deprecated. use PROJECT_ENTERED_{state} instead.
  A `HistoryLogEntry` recording a Project changing state.
  The value of this `HistoryLogEntryCode` is `5500`.

  See Also:
    Constant Field Values

### PROJECT_ENTERED_ACTIVE

    static final int PROJECT_ENTERED_ACTIVE

  A `HistoryLogEntry` recording a Project entering ACTIVE state.
  The value of this `HistoryLogEntryCode` is `5505`.

  See Also:
    Constant Field Values

### PROJECT_ENTERED_REVIEW

    static final int PROJECT_ENTERED_REVIEW

  A `HistoryLogEntry` recording a Project entering REVIEW state.
  The value of this `HistoryLogEntryCode` is `5510`.

  See Also:
    Constant Field Values

### PROJECT_ENTERED_REJECTED

    static final int PROJECT_ENTERED_REJECTED

  A `HistoryLogEntry` recording a Project entering REJECTED state.
  The value of this `HistoryLogEntryCode` is `5520`.

  See Also:
    Constant Field Values

### PROJECT_ENTERED_SYNDICATING

    static final int PROJECT_ENTERED_SYNDICATING

  A `HistoryLogEntry` recording a Project entering SYNDICATING state.
  The value of this `HistoryLogEntryCode` is `5530`.

  See Also:
    Constant Field Values

### PROJECT_ENTERED_PENDING

    static final int PROJECT_ENTERED_PENDING

  A `HistoryLogEntry` recording a Project entering PENDING state.
  The value of this `HistoryLogEntryCode` is `5540`.

  See Also:
    Constant Field Values

### PROJECT_ENTERED_PUBLISHING

    static final int PROJECT_ENTERED_PUBLISHING

  A `HistoryLogEntry` recording a Project entering PUBLISHING state.
  The value of this `HistoryLogEntryCode` is `5550`.

  See Also:
    Constant Field Values

### PROJECT_ENTERED_PUBLISHED

    static final int PROJECT_ENTERED_PUBLISHED

  A `HistoryLogEntry` recording a Project entering PUBLISHED state.
  The value of this `HistoryLogEntryCode` is `5560`.

  See Also:
    Constant Field Values

### PROJECT_ENTERED_PUBLISH_FAILED

    static final int PROJECT_ENTERED_PUBLISH_FAILED

  A `HistoryLogEntry` recording a Project entering PUBLISHED_FAILED state.
  The value of this `HistoryLogEntryCode` is `5570`.

  See Also:
    Constant Field Values

### PROJECT_PUBLISHED_STATE

    static final int PROJECT_PUBLISHED_STATE

  A `HistoryLogEntry` recording a Project changing state.
  The value of this `HistoryLogEntryCode` is `5600`.

  See Also:
    Constant Field Values

### PROJECT_SUBMITTED_FOR_REVIEW

    static final int PROJECT_SUBMITTED_FOR_REVIEW

  A `HistoryLogEntry` recording a Project being submitted for Review.
  The value of this `HistoryLogEntryCode` is `5700`.

  See Also:
    Constant Field Values

### PROJECT_WITHDRAWN_FROM_REVIEW

    static final int PROJECT_WITHDRAWN_FROM_REVIEW

  A `HistoryLogEntry` recording a Project being withdrawn from Review.
  The value of this `HistoryLogEntryCode` is `5750`.

  See Also:
    Constant Field Values

### PROJECT_APPROVED

    static final int PROJECT_APPROVED

  A `HistoryLogEntry` recording a Project being approved.
  The value of this `HistoryLogEntryCode` is `5800`.

  See Also:
    Constant Field Values

### PROJECT_REJECTED

    static final int PROJECT_REJECTED

  A `HistoryLogEntry` recording a Project being rejected.
  The value of this `HistoryLogEntryCode` is `5850`.

  See Also:
    Constant Field Values

### PROJECT_APPROVAL_WITHDRAWN

    static final int PROJECT_APPROVAL_WITHDRAWN

  A `HistoryLogEntry` recording an approval being removed from a Project.
  The value of this `HistoryLogEntryCode` is `5900`.

  See Also:
    Constant Field Values

### COMMENT_DRAFT_CANCELED

    static final int COMMENT_DRAFT_CANCELED

  A free form comment `HistoryLogEntry` entered when a draft Document was cancelLed.
  The value of this `HistoryLogEntryCode` is `10100`.

  See Also:
    Constant Field Values

### COMMENT_DRAFT_CREATED

    static final int COMMENT_DRAFT_CREATED

  A free form comment `HistoryLogEntry` entered when a draft Document was created.
  The value of this `HistoryLogEntryCode` is `10200`.

  See Also:
    Constant Field Values

### COMMENT_WORKFLOW_APPROVED

    static final int COMMENT_WORKFLOW_APPROVED

  A free form comment `HistoryLogEntry` entered when a Document was reviewed and approved.
  The value of this `HistoryLogEntryCode` is `10300`.

  See Also:
    Constant Field Values

### COMMENT_WORKFLOW_REJECTED

    static final int COMMENT_WORKFLOW_REJECTED

  A free form comment `HistoryLogEntry` entered when a Document was reviewed and rejected.
  The value of this `HistoryLogEntryCode` is `10400`.

  See Also:
    Constant Field Values

### COMMENT_WORKFLOW_PUBLISHED

    static final int COMMENT_WORKFLOW_PUBLISHED

  A free form comment `HistoryLogEntry` entered when a Document was published.
  The value of this `HistoryLogEntryCode` is `10500`.

  See Also:
    Constant Field Values

### COMMENT_WORKFLOW_NEXT_STAGE

    static final int COMMENT_WORKFLOW_NEXT_STAGE

  A free form comment `HistoryLogEntry` entered when a Document was moved to the next Workflow stage.
  The value of this `HistoryLogEntryCode` is `10600`.

  See Also:
    Constant Field Values

### COMMENT_WORKFLOW_PREVIOUS_STAGE

    static final int COMMENT_WORKFLOW_PREVIOUS_STAGE

  A free form comment `HistoryLogEntry` entered when a Document was moved to the previous Workflow stage.
  The value of this `HistoryLogEntryCode` is `10700`.

  See Also:
    Constant Field Values

### COMMENT_WORKFLOW_PROCESS_NOW

    static final int COMMENT_WORKFLOW_PROCESS_NOW

  A free form comment `HistoryLogEntry` entered when a Document manually executed a scheduled action.
  The value of this `HistoryLogEntryCode` is `10800`.

  See Also:
    Constant Field Values

### COMMENT_WORKFLOW_RESTARTED

    static final int COMMENT_WORKFLOW_RESTARTED

  A free form comment `HistoryLogEntry` entered when the Workflow was restarted on a Document.
  The value of this `HistoryLogEntryCode` is `10900`.

  See Also:
    Constant Field Values

### API_FREE_FORM_MESSAGE

    static final int API_FREE_FORM_MESSAGE

  A free form `HistoryLogEntry` created using the public API.
  The value of this `HistoryLogEntryCode` is `11100`.

  See Also:
    Constant Field Values

### COMMENT_PROJECT_SUBMITTED_FOR_REVIEW

    static final int COMMENT_PROJECT_SUBMITTED_FOR_REVIEW

  A free form comment `HistoryLogEntry` entered when a Project is submitted for Review.
  The value of this `HistoryLogEntryCode` is `11200`.

  See Also:
    Constant Field Values

### COMMENT_PROJECT_WITHDRAWN_FROM_REVIEW

    static final int COMMENT_PROJECT_WITHDRAWN_FROM_REVIEW

  A free form comment `HistoryLogEntry` entered when a Project is withdrawn for Review.
  The value of this `HistoryLogEntryCode` is `11300`.

  See Also:
    Constant Field Values

### COMMENT_PROJECT_APPROVAL_WITHDRAWN

    static final int COMMENT_PROJECT_APPROVAL_WITHDRAWN

  A free form comment `HistoryLogEntry` entered when an approval is withdrawn from a Project.
  The value of this `HistoryLogEntryCode` is `11600`.

  See Also:
    Constant Field Values

### HISTORY_ENTRIES_REMOVED

    static final int HISTORY_ENTRIES_REMOVED

  A `HistoryLogEntry` recording that the `HistoryLog` has entries removed.
  The value of this `HistoryLogEntryCode` is `20100`.

  See Also:
    Constant Field Values

Overview | Package | Class | Tree | Serialized | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD